Mask

SpreadJS supports setting a mask on a style in order to put constraints on user input.

Description
app.js
index.html
styles.css
Copy to CodeMine

You can set the mask of a cell in the following way:

    var style = new GC.Spread.Sheets.Style();
    style.mask = {
        pattern: '[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)'
    }

You can verify the pattern is legal with the follow static function:

    var verifyResult = GC.Spread.Sheets.InputMask.validatePattern('[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)');
    // if the verifyResult.success is true, means the pattern is legal
    // if the verifyResult.success is false, means the pattern is illegal, 
    // and the verifyResult.message will shows why it is illegal.

The mask supports detailed information with the following settings:

  • pattern
  • placeholder
  • excludeLiteral
  • excludePlaceholder

Default Values:

  • placeholder: '_'
You can set the mask of a cell in the following way: You can verify the pattern is legal with the follow static function: The mask supports detailed information with the following settings: pattern placeholder excludeLiteral excludePlaceholder Default Values: placeholder: '_'
window.onload = function () { let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 1 }); initSpread(spread); }; function initSpread(spread) { initSheet(spread); bindEvents(spread); } function initSheet (spread) { let sheet = spread.getActiveSheet(); sheet.suspendPaint(); sheet.setValue(0, 0, 'Mask Cell'); sheet.setColumnWidth(0, 240); sheet.setValue(0, 1, 'Mask Pattern or Option'); sheet.setColumnWidth(1, 240); sheet.setValue(0, 2, 'Mask Description'); sheet.setColumnWidth(2, 240); let style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "a" }; sheet.setStyle(1, 0, style); sheet.setValue(1, 1, 'a'); sheet.setValue(1, 2, 'User must enter a letter.'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: ">" }; sheet.setStyle(2, 0, style); sheet.setValue(2, 1, '>'); sheet.setValue(2, 2, 'User must enter a letter and auto convert it to uppercase'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "<" }; sheet.setStyle(3, 0, style); sheet.setValue(3, 1, '<'); sheet.setValue(3, 2, 'User must enter a letter and auto convert it to lowercase.'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "0" }; sheet.setStyle(4, 0, style); sheet.setValue(4, 1, '0'); sheet.setValue(4, 2, 'User must enter a digit(0-9).'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)" }; sheet.setStyle(5, 0, style); sheet.setValue(5, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)'); sheet.setValue(5, 2, '() Indicates that any one of the strings in () will match.'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)" }; sheet.setStyle(6, 0, style); sheet.setValue(6, 1, 'Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)'); sheet.setValue(6, 2, '| Used within () and acts as a delimiter between strings.'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "[a0_]" }; sheet.setStyle(7, 0, style); sheet.setValue(7, 1, '[a0_]'); sheet.setValue(7, 2, 'For combine the keywords and literals as a whole'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "0{3}" }; sheet.setStyle(8, 0, style); sheet.setValue(8, 1, '0{3}'); sheet.setValue(8, 2, 'n repeats'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "0{2,4}" }; sheet.setStyle(9, 0, style); sheet.setValue(9, 1, '0{2,4}'); sheet.setValue(9, 2, 'From n to m repeats'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "0{,3}" }; sheet.setStyle(10, 0, style); sheet.setValue(10, 1, '0{,3}'); sheet.setValue(10, 2, 'Up to m repeats'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "0{3,}" }; sheet.setStyle(11, 0, style); sheet.setValue(11, 1, '0{3,}'); sheet.setValue(11, 2, 'At least n repeats'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "0{1,}.\\0\\0" }; sheet.setStyle(12, 0, style); sheet.setValue(12, 1, '0{1,}.\\0\\0'); sheet.setValue(12, 2, 'Escape Character'); 5 style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "000.000", placeholder: "-" }; sheet.setStyle(13, 0, style); sheet.setValue(13, 1, '000.000'); sheet.setValue(13, 2, 'placeholder: -'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "[a0]{8}", excludePlaceholder: true }; sheet.setStyle(14, 0, style); sheet.setValue(14, 1, '[a0]{8}'); sheet.setValue(14, 2, 'excludePlaceholder: true'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)", excludeLiteral: true }; sheet.setStyle(15, 0, style); sheet.setValue(15, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)'); sheet.setValue(15, 2, 'excludeLiteral: true'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)" }; sheet.setStyle(16, 0, style); sheet.setValue(16, 1, '[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)'); sheet.setValue(16, 2, 'email'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "><{1,} ><{1,}" }; sheet.setStyle(17, 0, style); sheet.setValue(17, 1, '><{1,} ><{1,}'); sheet.setValue(17, 2, 'name(First letter auto uppercase)'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "[>0]{5}" }; sheet.setStyle(18, 0, style); sheet.setValue(18, 1, '[>0]{5}'); sheet.setValue(18, 2, 'Verify Code, include letter and number, letter auto convert uppercase'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "yyyy/MM/dd" }; sheet.setStyle(19, 0, style); sheet.setValue(19, 1, 'yyyy/MM/dd'); sheet.setValue(19, 2, 'Date'); style = new GC.Spread.Sheets.Style(); style.mask = { pattern: "hh:mm:ss tt" }; sheet.setStyle(20, 0, style); sheet.setValue(20, 1, 'hh:mm:ss tt'); sheet.setValue(20, 2, 'Time'); sheet.resumePaint(); } function updateValidation (value) { let validation = document.getElementById('validation'); let validateResult = GC.Spread.Sheets.InputMask.validatePattern(value); if (!validateResult.success) { validation.innerText = validateResult.message || 'Invalid Pattern'; } else { validation.innerText = ''; } } function bindEvents (spread) { document.getElementById("set-mask").addEventListener('click', function () { set(spread); }); let pattern = document.getElementById('pattern'); pattern.addEventListener('keyup', function (event) { updateValidation(event.target.value); }); spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () { setSettings(spread); }); } function setSettings (spread) { let sheet = spread.getActiveSheet(); let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex()); let mask = activeCell.mask(), pattern = '', placeholder = '', excludeLiteral = false, excludePlaceholder = false; if (mask) { pattern = mask.pattern || ''; placeholder = mask.placeholder || ''; excludeLiteral = mask.excludeLiteral || false; excludePlaceholder = mask.excludePlaceholder || false; } document.getElementById('pattern').value = pattern; document.getElementById('placeholder').value = placeholder; document.getElementById('excludeLiteral').checked = excludeLiteral; document.getElementById('excludePlaceholder').checked = excludePlaceholder; updateValidation(pattern); } function set (spread) { let sheet = spread.getActiveSheet(); let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex()); let pattern = document.getElementById('pattern').value || undefined, placeholder = document.getElementById('placeholder').value || undefined, excludeLiteral = document.getElementById('excludeLiteral').checked, excludePlaceholder = document.getElementById('excludePlaceholder').checked; if (pattern && pattern[0] === "=") { pattern = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, pattern); } activeCell.mask({ pattern, placeholder, excludeLiteral, excludePlaceholder }); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <p>Select a cell, then set mask for it.</p> <div class="settings-row"> <span id="validation"></span> </div> <div class="settings-row"> <label for="pattern">Pattern:</label><input type="text" id="pattern" class="settings-text"> </div> <div class="settings-row"> <label for="placeholder">Placeholder:</label><input type="text" id="placeholder" maxlength="1" class="settings-text"> </div> <div class="settings-row"> <label for="excludeLiteral">ExcludeLiteral:</label><input type="checkbox" class="settings-text" id="excludeLiteral"> </div> <div class="settings-row"> <label for="excludePlaceholder">ExcludePlaceholder:</label><input type="checkbox" class="settings-text" id="excludePlaceholder"> </div> <div class="settings-row"> <button id="set-mask" class="settings-btn">Set</button> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } label { display: inline-block; width: 135px; } #validation { font-size: 10px; color: red; } .settings-row { width: 100%; height: 30px; font-size: 13px; } .settings-text { display: inline-block; width: 100px; } .settings-btn { display: inline-block; width: 100px; height: 30px; margin-left: 20px; }

You can set the mask of a cell in the following way:
You can verify the pattern is legal with the follow static function:
The mask supports detailed information with the following settings:
pattern
placeholder
excludeLiteral
excludePlaceholder
Default Values:
placeholder: '_'
import { Component, NgModule, enableProdMode, NgZone } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@grapecity/spread-sheets-angular';
import { FormsModule } from '@angular/forms';
import GC from '@grapecity/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
pattern = '';
placeholder = '';
validation = '';
excludeLiteral = false;
excludePlaceholder = false;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor (private zone: NgZone) {}
initSpread($event: any) {
let spread = $event.spread;
this.spread = spread;
this.initSheet(spread);
this.bindEvents(spread);
}
initSheet (spread: GC.Spread.Sheets.Workbook) {
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
sheet.setValue(0, 0, 'Mask Cell');
sheet.setColumnWidth(0, 240);
sheet.setValue(0, 1, 'Mask Pattern or Option');
sheet.setColumnWidth(1, 240);
sheet.setValue(0, 2, 'Mask Description');
sheet.setColumnWidth(2, 240);
let style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "a"
};
sheet.setStyle(1, 0, style);
sheet.setValue(1, 1, 'a');
sheet.setValue(1, 2, 'User must enter a letter.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: ">"
};
sheet.setStyle(2, 0, style);
sheet.setValue(2, 1, '>');
sheet.setValue(2, 2, 'User must enter a letter and auto convert it to uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "<"
};
sheet.setStyle(3, 0, style);
sheet.setValue(3, 1, '<');
sheet.setValue(3, 2, 'User must enter a letter and auto convert it to lowercase.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0"
};
sheet.setStyle(4, 0, style);
sheet.setValue(4, 1, '0');
sheet.setValue(4, 2, 'User must enter a digit(0-9).');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)"
};
sheet.setStyle(5, 0, style);
sheet.setValue(5, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(5, 2, '() Indicates that any one of the strings in () will match.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)"
};
sheet.setStyle(6, 0, style);
sheet.setValue(6, 1, 'Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)');
sheet.setValue(6, 2, '| Used within () and acts as a delimiter between strings.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0_]"
};
sheet.setStyle(7, 0, style);
sheet.setValue(7, 1, '[a0_]');
sheet.setValue(7, 2, 'For combine the keywords and literals as a whole');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3}"
};
sheet.setStyle(8, 0, style);
sheet.setValue(8, 1, '0{3}');
sheet.setValue(8, 2, 'n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{2,4}"
};
sheet.setStyle(9, 0, style);
sheet.setValue(9, 1, '0{2,4}');
sheet.setValue(9, 2, 'From n to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{,3}"
};
sheet.setStyle(10, 0, style);
sheet.setValue(10, 1, '0{,3}');
sheet.setValue(10, 2, 'Up to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3,}"
};
sheet.setStyle(11, 0, style);
sheet.setValue(11, 1, '0{3,}');
sheet.setValue(11, 2, 'At least n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{1,}.\\0\\0"
};
sheet.setStyle(12, 0, style);
sheet.setValue(12, 1, '0{1,}.\\0\\0');
sheet.setValue(12, 2, 'Escape Character');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "000.000",
placeholder: "-"
};
sheet.setStyle(13, 0, style);
sheet.setValue(13, 1, '000.000');
sheet.setValue(13, 2, 'placeholder: -');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{8}",
excludePlaceholder: true
};
sheet.setStyle(14, 0, style);
sheet.setValue(14, 1, '[a0]{8}');
sheet.setValue(14, 2, 'excludePlaceholder: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)",
excludeLiteral: true
};
sheet.setStyle(15, 0, style);
sheet.setValue(15, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(15, 2, 'excludeLiteral: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)"
};
sheet.setStyle(16, 0, style);
sheet.setValue(16, 1, '[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)');
sheet.setValue(16, 2, 'email');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "><{1,} ><{1,}"
};
sheet.setStyle(17, 0, style);
sheet.setValue(17, 1, '><{1,} ><{1,}');
sheet.setValue(17, 2, 'name(First letter auto uppercase)');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[>0]{5}"
};
sheet.setStyle(18, 0, style);
sheet.setValue(18, 1, '[>0]{5}');
sheet.setValue(18, 2, 'Verify Code, include letter and number, letter auto convert uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "yyyy/MM/dd"
};
sheet.setStyle(19, 0, style);
sheet.setValue(19, 1, 'yyyy/MM/dd');
sheet.setValue(19, 2, 'Date');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "hh:mm:ss tt"
};
sheet.setStyle(20, 0, style);
sheet.setValue(20, 1, 'hh:mm:ss tt');
sheet.setValue(20, 2, 'Time');
sheet.resumePaint();
}
bindEvents (spread: GC.Spread.Sheets.Workbook) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.setSettings(spread);
});
}
onKeyup () {
let value = this.pattern;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(value);
if (validateResult.success) {
this.validation = '';
} else {
this.validation = validateResult.message || 'Invalid Pattern';
}
}
setSettings (spread: GC.Spread.Sheets.Workbook) {
let sheet = spread.getActiveSheet();
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());let mask = activeCell.mask(), pattern = '', placeholder = '', excludeLiteral = false, excludePlaceholder = false;
if (mask) {
pattern = mask.pattern || '';
placeholder = mask.placeholder || '';
excludeLiteral = mask.excludeLiteral || false;
excludePlaceholder = mask.excludePlaceholder || false;
}
this.zone.run(() => {
this.pattern = pattern;
this.placeholder = placeholder;
this.excludeLiteral = excludeLiteral;
this.excludePlaceholder = excludePlaceholder;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(pattern);
if (validateResult.success) {
this.validation = '';
} else {
this.validation = validateResult.message || 'Invalid Pattern';
}
});
}
set () {
let self = this, sheet = this.spread.getActiveSheet();
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
let pattern = self.pattern || undefined;
if (pattern && pattern[0] === "=") {
pattern = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, pattern);
}
activeCell.mask({
pattern: pattern,
placeholder: self.placeholder || undefined,
excludeLiteral: self.excludeLiteral,
excludePlaceholder: self.excludePlaceholder
});
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/dist/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<p>Select a cell, then set mask for it.</p>
<div class="settings-row">
<span id="validation">{{ validation }}</span>
</div>
<div class="settings-row">
<label for="pattern">Pattern:</label><input type="text" id="pattern" class="settings-text" [(ngModel)]="pattern" (keyup)="onKeyup($event)">
</div>
<div class="settings-row">
<label for="placeholder">Placeholder:</label><input type="text" maxlength="1" id="placeholder" class="settings-text" [(ngModel)]="placeholder">
</div>
<div class="settings-row">
<label for="excludeLiteral">ExcludeLiteral:</label><input type="checkbox" class="settings-text" id="excludeLiteral" [(ngModel)]="excludeLiteral">
</div>
<div class="settings-row">
<label for="excludePlaceholder">ExcludePlaceholder:</label><input type="checkbox" class="settings-text" id="excludePlaceholder" [(ngModel)]="excludePlaceholder">
</div>
<div class="settings-row">
<button id="set-mask" class="settings-btn" (click)="set()">Set</button>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 135px;
}
#validation {
font-size: 10px;
color: red;
}
.settings-row {
width: 100%;
height: 30px;
font-size: 13px;
}
.settings-text {
display: inline-block;
width: 100px;
}
.settings-btn {
display: inline-block;
width: 100px;
height: 30px;
margin-left: 20px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/dist/zone.min.js',
'rxjs': 'npm:rxjs/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/bundles/core.umd.min.js',
'@angular/common': 'npm:@angular/common/bundles/common.umd.min.js',
'@angular/compiler': 'npm:@angular/compiler/bundles/compiler.umd.min.js',
'@angular/platform-browser': 'npm:@angular/platform-browser/bundles/platform-browser.umd.min.js',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/bundles/platform-browser-dynamic.umd.min.js',
'@angular/http': 'npm:@angular/http/bundles/http.umd.min.js',
'@angular/common/http': 'npm:@angular/common/bundles/common-http.umd.min.js',
'@angular/router': 'npm:@angular/router/bundles/router.umd.min.js',
'@angular/forms': 'npm:@angular/forms/bundles/forms.umd.min.js',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': 'npm:plugin-typescript/lib/plugin.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@grapecity/spread-sheets': 'npm:@grapecity/spread-sheets/index.js',
'@grapecity/spread-sheets-angular': 'npm:@grapecity/spread-sheets-angular/bundles/grapecity-spread-sheets-angular.umd.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can set the mask of a cell in the following way:
You can verify the pattern is legal with the follow static function:
The mask supports detailed information with the following settings:
pattern
placeholder
excludeLiteral
excludePlaceholder
Default Values:
placeholder: '_'
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<p>Select a cell, then set mask for it.</p>
<div class="settings-row">
<span id="validation" v-model="validation"></span>
</div>
<div class="settings-row">
<label for="pattern">Pattern:</label><input type="text" id="pattern" class="settings-text" v-model="pattern" v-on:keyup="onKeyup">
</div>
<div class="settings-row">
<label for="placeholder">Placeholder:</label><input type="text" id="placeholder" class="settings-text" maxlength="1" v-model="placeholder">
</div>
<div class="settings-row">
<label for="excludeLiteral">ExcludeLiteral:</label><input type="checkbox" class="settings-text" id="excludeLiteral" v-model="excludeLiteral">
</div>
<div class="settings-row">
<label for="excludePlaceholder">ExcludePlaceholder:</label><input type="checkbox" class="settings-text" id="excludePlaceholder" v-model="excludePlaceholder">
</div>
<div class="settings-row">
<button id="set-mask" class="settings-btn" v-on:click="set">Set</button>
</div>
</div>
</div>
</template>
<script>
import Vue from 'vue';
import '@mescius/spread-sheets-vue'
import GC from '@mescius/spread-sheets';
import './styles.css';
let App = Vue.extend({
name: "app",
data: function() {
return {
pattern: '',
placeholder: "",
validation: '',
excludeLiteral: false,
excludePlaceholder: false,
spread: null
};
},
methods:{
initSpread(spread) {
this.spread = spread;
this.initSheet(spread);
this.bindEvents(spread);
},
initSheet (spread) {
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
sheet.setValue(0, 0, 'Mask Cell');
sheet.setColumnWidth(0, 240);
sheet.setValue(0, 1, 'Mask Pattern or Option');
sheet.setColumnWidth(1, 240);
sheet.setValue(0, 2, 'Mask Description');
sheet.setColumnWidth(2, 240);
let style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "a"
};
sheet.setStyle(1, 0, style);
sheet.setValue(1, 1, 'a');
sheet.setValue(1, 2, 'User must enter a letter.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: ">"
};
sheet.setStyle(2, 0, style);
sheet.setValue(2, 1, '>');
sheet.setValue(2, 2, 'User must enter a letter and auto convert it to uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "<"
};
sheet.setStyle(3, 0, style);
sheet.setValue(3, 1, '<');
sheet.setValue(3, 2, 'User must enter a letter and auto convert it to lowercase.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0"
};
sheet.setStyle(4, 0, style);
sheet.setValue(4, 1, '0');
sheet.setValue(4, 2, 'User must enter a digit(0-9).');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)"
};
sheet.setStyle(5, 0, style);
sheet.setValue(5, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(5, 2, '() Indicates that any one of the strings in () will match.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)"
};
sheet.setStyle(6, 0, style);
sheet.setValue(6, 1, 'Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)');
sheet.setValue(6, 2, '| Used within () and acts as a delimiter between strings.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0_]"
};
sheet.setStyle(7, 0, style);
sheet.setValue(7, 1, '[a0_]');
sheet.setValue(7, 2, 'For combine the keywords and literals as a whole');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3}"
};
sheet.setStyle(8, 0, style);
sheet.setValue(8, 1, '0{3}');
sheet.setValue(8, 2, 'n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{2,4}"
};
sheet.setStyle(9, 0, style);
sheet.setValue(9, 1, '0{2,4}');
sheet.setValue(9, 2, 'From n to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{,3}"
};
sheet.setStyle(10, 0, style);
sheet.setValue(10, 1, '0{,3}');
sheet.setValue(10, 2, 'Up to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3,}"
};
sheet.setStyle(11, 0, style);
sheet.setValue(11, 1, '0{3,}');
sheet.setValue(11, 2, 'At least n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{1,}.\\0\\0"
};
sheet.setStyle(12, 0, style);
sheet.setValue(12, 1, '0{1,}.\\0\\0');
sheet.setValue(12, 2, 'Escape Character');
5
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "000.000",
placeholder: "-"
};
sheet.setStyle(13, 0, style);
sheet.setValue(13, 1, '000.000');
sheet.setValue(13, 2, 'placeholder: -');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{8}",
excludePlaceholder: true
};
sheet.setStyle(14, 0, style);
sheet.setValue(14, 1, '[a0]{8}');
sheet.setValue(14, 2, 'excludePlaceholder: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)",
excludeLiteral: true
};
sheet.setStyle(15, 0, style);
sheet.setValue(15, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(15, 2, 'excludeLiteral: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)"
};
sheet.setStyle(16, 0, style);
sheet.setValue(16, 1, '[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)');
sheet.setValue(16, 2, 'email');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "><{1,} ><{1,}"
};
sheet.setStyle(17, 0, style);
sheet.setValue(17, 1, '><{1,} ><{1,}');
sheet.setValue(17, 2, 'name(First letter auto uppercase)');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[>0]{5}"
};
sheet.setStyle(18, 0, style);
sheet.setValue(18, 1, '[>0]{5}');
sheet.setValue(18, 2, 'Verify Code, include letter and number, letter auto convert uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "yyyy/MM/dd"
};
sheet.setStyle(19, 0, style);
sheet.setValue(19, 1, 'yyyy/MM/dd');
sheet.setValue(19, 2, 'Date');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "hh:mm:ss tt"
};
sheet.setStyle(20, 0, style);
sheet.setValue(20, 1, 'hh:mm:ss tt');
sheet.setValue(20, 2, 'Time');
sheet.resumePaint();
},
bindEvents (spread) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.setSettings(spread);
});
},
onKeyup () {
let value = this.pattern;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(value);
if (validateResult.success) {
this.validation = '';
} else {
this.validation = validateResult.message || 'Invalid Pattern';
}
},
setSettings (spread) {
let sheet = spread.getActiveSheet();
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());let mask = activeCell.mask(), pattern = '', placeholder = '', excludeLiteral = false, excludePlaceholder = false;
if (mask) {
pattern = mask.pattern || '';
placeholder = mask.placeholder || '';
excludeLiteral = mask.excludeLiteral || false;
excludePlaceholder = mask.excludePlaceholder || false;
}
this.pattern = pattern;
this.placeholder = placeholder;
this.excludeLiteral = excludeLiteral;
this.excludePlaceholder = excludePlaceholder;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(pattern);
if (validateResult.success) {
this.validation = '';
} else {
this.validation = validateResult.message || 'Invalid Pattern';
}
},
set () {
let self = this, sheet = this.spread.getActiveSheet();
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
let pattern = self.pattern || undefined;
if (pattern && pattern[0] === "=") {
pattern = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, pattern);
}
activeCell.mask({
pattern: pattern,
placeholder: self.placeholder || undefined,
excludeLiteral: self.excludeLiteral,
excludePlaceholder: self.excludePlaceholder
});
}
}
});
new Vue({ render: h => h(App) }).$mount('#app');
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/en/lib/vue/license.js');
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 135px;
}
.settings-row {
width: 100%;
height: 30px;
font-size: 13px;
}
.settings-text {
display: inline-block;
width: 100px;
}
.settings-btn {
display: inline-block;
width: 100px;
height: 30px;
margin-left: 20px;
}
#validation {
font-size: 10px;
color: red;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);

You can set the mask of a cell in the following way:
You can verify the pattern is legal with the follow static function:
The mask supports detailed information with the following settings:
pattern
placeholder
excludeLiteral
excludePlaceholder
Default Values:
placeholder: '_'
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
let spread = null;
export function AppFunc() {
const [maskOption, setMaskOption] = React.useState({
pattern: '',
placeholder: '',
excludeLiteral: false,
excludePlaceholder: false
});
const handleInputClick = (event) => {
const target = event.target;
const value = target.checked;
const name = target.name;
setMaskOption({
...maskOption,
[name]: value
});
}
const handleInputChange = (event) => {
const target = event.target;
const value = target.value;
const name = target.name;
setMaskOption({
...maskOption,
[name]: value
});
}
const handleKeyUp = (event) => {
let target = event.target;
let value = target.value;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(value);
if (validateResult.success) {
setMaskOption({
...maskOption,
validation: ''
});
} else {
setMaskOption({
...maskOption,
validation: validateResult.message || 'Invalid Pattern'
});
}
}
const initSpread = (currSpread) => {
spread = currSpread;
initSheet();
bindEvents();
}
const initSheet = () => {
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
sheet.setValue(0, 0, 'Mask Cell');
sheet.setColumnWidth(0, 240);
sheet.setValue(0, 1, 'Mask Pattern or Option');
sheet.setColumnWidth(1, 240);
sheet.setValue(0, 2, 'Mask Description');
sheet.setColumnWidth(2, 240);
let style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "a"
};
sheet.setStyle(1, 0, style);
sheet.setValue(1, 1, 'a');
sheet.setValue(1, 2, 'User must enter a letter.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: ">"
};
sheet.setStyle(2, 0, style);
sheet.setValue(2, 1, '>');
sheet.setValue(2, 2, 'User must enter a letter and auto convert it to uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "<"
};
sheet.setStyle(3, 0, style);
sheet.setValue(3, 1, '<');
sheet.setValue(3, 2, 'User must enter a letter and auto convert it to lowercase.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0"
};
sheet.setStyle(4, 0, style);
sheet.setValue(4, 1, '0');
sheet.setValue(4, 2, 'User must enter a digit(0-9).');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)"
};
sheet.setStyle(5, 0, style);
sheet.setValue(5, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(5, 2, '() Indicates that any one of the strings in () will match.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)"
};
sheet.setStyle(6, 0, style);
sheet.setValue(6, 1, 'Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)');
sheet.setValue(6, 2, '| Used within () and acts as a delimiter between strings.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0_]"
};
sheet.setStyle(7, 0, style);
sheet.setValue(7, 1, '[a0_]');
sheet.setValue(7, 2, 'For combine the keywords and literals as a whole');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3}"
};
sheet.setStyle(8, 0, style);
sheet.setValue(8, 1, '0{3}');
sheet.setValue(8, 2, 'n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{2,4}"
};
sheet.setStyle(9, 0, style);
sheet.setValue(9, 1, '0{2,4}');
sheet.setValue(9, 2, 'From n to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{,3}"
};
sheet.setStyle(10, 0, style);
sheet.setValue(10, 1, '0{,3}');
sheet.setValue(10, 2, 'Up to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3,}"
};
sheet.setStyle(11, 0, style);
sheet.setValue(11, 1, '0{3,}');
sheet.setValue(11, 2, 'At least n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{1,}.\\0\\0"
};
sheet.setStyle(12, 0, style);
sheet.setValue(12, 1, '0{1,}.\\0\\0');
sheet.setValue(12, 2, 'Escape Character');
5
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "000.000",
placeholder: "-"
};
sheet.setStyle(13, 0, style);
sheet.setValue(13, 1, '000.000');
sheet.setValue(13, 2, 'placeholder: -');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{8}",
excludePlaceholder: true
};
sheet.setStyle(14, 0, style);
sheet.setValue(14, 1, '[a0]{8}');
sheet.setValue(14, 2, 'excludePlaceholder: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)",
excludeLiteral: true
};
sheet.setStyle(15, 0, style);
sheet.setValue(15, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(15, 2, 'excludeLiteral: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)"
};
sheet.setStyle(16, 0, style);
sheet.setValue(16, 1, '[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)');
sheet.setValue(16, 2, 'email');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "><{1,} ><{1,}"
};
sheet.setStyle(17, 0, style);
sheet.setValue(17, 1, '><{1,} ><{1,}');
sheet.setValue(17, 2, 'name(First letter auto uppercase)');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[>0]{5}"
};
sheet.setStyle(18, 0, style);
sheet.setValue(18, 1, '[>0]{5}');
sheet.setValue(18, 2, 'Verify Code, include letter and number, letter auto convert uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "yyyy/MM/dd"
};
sheet.setStyle(19, 0, style);
sheet.setValue(19, 1, 'yyyy/MM/dd');
sheet.setValue(19, 2, 'Date');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "hh:mm:ss tt"
};
sheet.setStyle(20, 0, style);
sheet.setValue(20, 1, 'hh:mm:ss tt');
sheet.setValue(20, 2, 'Time');
sheet.resumePaint();
}
const bindEvents = () => {
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
setSettings();
});
}
const setSettings = () => {
let sheet = spread.getActiveSheet();
let state = { ...maskOption };
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
let mask = activeCell.mask(), pattern = '', placeholder = '', excludeLiteral = false, excludePlaceholder = false;
if (mask) {
pattern = mask.pattern || '';
placeholder = mask.placeholder || '';
excludeLiteral = mask.excludeLiteral || false;
excludePlaceholder = mask.excludePlaceholder || false;
}
state.pattern = pattern;
state.placeholder = placeholder;
state.excludeLiteral = excludeLiteral;
state.excludePlaceholder = excludePlaceholder;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(pattern);
if (validateResult.success) {
state.validation = '';
} else {
state.validation = validateResult.message || 'Invalid Pattern';
}
setMaskOption(state);
}
const set = () => {
let sheet = spread.getActiveSheet(), state = { ...maskOption };
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
let pattern = state.pattern || undefined;
if (pattern && pattern[0] === "=") {
pattern = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, pattern);
}
activeCell.mask({
pattern: pattern,
placeholder: state.placeholder || undefined,
excludeLiteral: state.excludeLiteral,
excludePlaceholder: state.excludePlaceholder
});
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread} />
</div>
<div class="options-container">
<p>Select a cell, then set mask for it.</p>
<div className="settings-row">
<span id="validation" name={'validation'}>{maskOption.validation}</span>
</div>
<div class="settings-row">
<label for="pattern">Pattern:</label><input type="text" id="pattern" name={'pattern'} class="settings-text" value={maskOption.pattern} onChange={handleInputChange} onKeyUp={handleKeyUp} />
</div>
<div class="settings-row">
<label for="placeholder">Placeholder:</label><input type="text" id="placeholder" maxlength="1" name={'placeholder'} class="settings-text" value={maskOption.placeholder} onChange={handleInputChange} />
</div>
<div class="settings-row">
<label for="excludeLiteral">ExcludeLiteral:</label><input type="checkbox" name={'excludeLiteral'} class="settings-text" id="excludeLiteral" checked={maskOption.excludeLiteral} onChange={handleInputClick} />
</div>
<div class="settings-row">
<label for="excludePlaceholder">ExcludePlaceholder:</label><input type="checkbox" name={'excludePlaceholder'} class="settings-text" id="excludePlaceholder" checked={maskOption.excludePlaceholder} onChange={handleInputClick} />
</div>
<div class="settings-row">
<button id="set-mask" class="corner-btn" onClick={set}>Set</button>
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
pattern: '',
placeholder: "",
validation: '',
excludeLiteral: false,
excludePlaceholder: false
}
}
handleInputClick = (event) => {
const target = event.target;
const value = target.checked;
const name = target.name;
this.setState({
[name]: value
});
}
handleInputChange = (event) => {
const target = event.target;
const value = target.value;
const name = target.name;
this.setState({
[name]: value
});
}
handleKeyUp = (event) => {
let target = event.target;
let value = target.value;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(value);
if (validateResult.success) {
this.setState({
validation: ''
});
} else {
this.setState({
validation: validateResult.message || 'Invalid Pattern'
});
}
}
initSpread = (spread) => {
this.spread = spread;
this.initSheet(spread);
this.bindEvents(spread);
}
initSheet = (spread) => {
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
sheet.setValue(0, 0, 'Mask Cell');
sheet.setColumnWidth(0, 240);
sheet.setValue(0, 1, 'Mask Pattern or Option');
sheet.setColumnWidth(1, 240);
sheet.setValue(0, 2, 'Mask Description');
sheet.setColumnWidth(2, 240);
let style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "a"
};
sheet.setStyle(1, 0, style);
sheet.setValue(1, 1, 'a');
sheet.setValue(1, 2, 'User must enter a letter.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: ">"
};
sheet.setStyle(2, 0, style);
sheet.setValue(2, 1, '>');
sheet.setValue(2, 2, 'User must enter a letter and auto convert it to uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "<"
};
sheet.setStyle(3, 0, style);
sheet.setValue(3, 1, '<');
sheet.setValue(3, 2, 'User must enter a letter and auto convert it to lowercase.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0"
};
sheet.setStyle(4, 0, style);
sheet.setValue(4, 1, '0');
sheet.setValue(4, 2, 'User must enter a digit(0-9).');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)"
};
sheet.setStyle(5, 0, style);
sheet.setValue(5, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(5, 2, '() Indicates that any one of the strings in () will match.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)"
};
sheet.setStyle(6, 0, style);
sheet.setValue(6, 1, 'Br\\an\\d\\s: (Benz|BMW|Buick|BYD|Chevrolet|Dodge|Ford|Honda|Jeep|Mazda|Toyota|Volkswagen)');
sheet.setValue(6, 2, '| Used within () and acts as a delimiter between strings.');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0_]"
};
sheet.setStyle(7, 0, style);
sheet.setValue(7, 1, '[a0_]');
sheet.setValue(7, 2, 'For combine the keywords and literals as a whole');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3}"
};
sheet.setStyle(8, 0, style);
sheet.setValue(8, 1, '0{3}');
sheet.setValue(8, 2, 'n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{2,4}"
};
sheet.setStyle(9, 0, style);
sheet.setValue(9, 1, '0{2,4}');
sheet.setValue(9, 2, 'From n to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{,3}"
};
sheet.setStyle(10, 0, style);
sheet.setValue(10, 1, '0{,3}');
sheet.setValue(10, 2, 'Up to m repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{3,}"
};
sheet.setStyle(11, 0, style);
sheet.setValue(11, 1, '0{3,}');
sheet.setValue(11, 2, 'At least n repeats');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "0{1,}.\\0\\0"
};
sheet.setStyle(12, 0, style);
sheet.setValue(12, 1, '0{1,}.\\0\\0');
sheet.setValue(12, 2, 'Escape Character');
5
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "000.000",
placeholder: "-"
};
sheet.setStyle(13, 0, style);
sheet.setValue(13, 1, '000.000');
sheet.setValue(13, 2, 'placeholder: -');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{8}",
excludePlaceholder: true
};
sheet.setStyle(14, 0, style);
sheet.setValue(14, 1, '[a0]{8}');
sheet.setValue(14, 2, 'excludePlaceholder: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)",
excludeLiteral: true
};
sheet.setStyle(15, 0, style);
sheet.setValue(15, 1, 'Au\\t\\hor: (Chris|Icey|Victor|Ian|Johnson|Ivan)');
sheet.setValue(15, 2, 'excludeLiteral: true');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)"
};
sheet.setStyle(16, 0, style);
sheet.setValue(16, 1, '[a0]{1,}@[a0]{1,}.(com|cn|gov|edu)');
sheet.setValue(16, 2, 'email');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "><{1,} ><{1,}"
};
sheet.setStyle(17, 0, style);
sheet.setValue(17, 1, '><{1,} ><{1,}');
sheet.setValue(17, 2, 'name(First letter auto uppercase)');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "[>0]{5}"
};
sheet.setStyle(18, 0, style);
sheet.setValue(18, 1, '[>0]{5}');
sheet.setValue(18, 2, 'Verify Code, include letter and number, letter auto convert uppercase');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "yyyy/MM/dd"
};
sheet.setStyle(19, 0, style);
sheet.setValue(19, 1, 'yyyy/MM/dd');
sheet.setValue(19, 2, 'Date');
style = new GC.Spread.Sheets.Style();
style.mask = {
pattern: "hh:mm:ss tt"
};
sheet.setStyle(20, 0, style);
sheet.setValue(20, 1, 'hh:mm:ss tt');
sheet.setValue(20, 2, 'Time');
sheet.resumePaint();
}
bindEvents = (spread) => {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SelectionChanged, function () {
self.setSettings(spread);
});
}
setSettings = (spread)=> {
let sheet = spread.getActiveSheet();
let state = this.state;
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
let mask = activeCell.mask(), pattern = '', placeholder = '', excludeLiteral = false, excludePlaceholder = false;
if (mask) {
pattern = mask.pattern || '';
placeholder = mask.placeholder || '';
excludeLiteral = mask.excludeLiteral || false;
excludePlaceholder = mask.excludePlaceholder || false;
}
state.pattern = pattern;
state.placeholder = placeholder;
state.excludeLiteral = excludeLiteral;
state.excludePlaceholder = excludePlaceholder;
let validateResult = GC.Spread.Sheets.InputMask.validatePattern(pattern);
if (validateResult.success) {
state.validation = '';
} else {
state.validation = validateResult.message || 'Invalid Pattern';
}
this.setState(state);
}
set = () => {
let self = this, sheet = this.spread.getActiveSheet(), state = this.state;
let activeCell = sheet.getCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
let pattern = state.pattern || undefined;
if (pattern && pattern[0] === "=") {
pattern = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, pattern);
}
activeCell.mask({
pattern: pattern,
placeholder: state.placeholder || undefined,
excludeLiteral: state.excludeLiteral,
excludePlaceholder: state.excludePlaceholder
});
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={this.initSpread} />
</div>
<div class="options-container">
<p>Select a cell, then set mask for it.</p>
<div className="settings-row">
<span id="validation" name={'validation'}>{this.state.validation}</span>
</div>
<div class="settings-row">
<label for="pattern">Pattern:</label><input type="text" id="pattern" name={'pattern'} class="settings-text" value={this.state.pattern} onChange={this.handleInputChange} onKeyUp={this.handleKeyUp}/>
</div>
<div class="settings-row">
<label for="placeholder">Placeholder:</label><input type="text" id="placeholder" maxlength="1" name={'placeholder'} class="settings-text" value={this.state.placeholder} onChange={this.handleInputChange}/>
</div>
<div class="settings-row">
<label for="excludeLiteral">ExcludeLiteral:</label><input type="checkbox" name={'excludeLiteral'} class="settings-text" id="excludeLiteral" checked={this.state.excludeLiteral} onChange={this.handleInputClick}/>
</div>
<div class="settings-row">
<label for="excludePlaceholder">ExcludePlaceholder:</label><input type="checkbox" name={'excludePlaceholder'} class="settings-text" id="excludePlaceholder" checked={this.state.excludePlaceholder} onChange={this.handleInputClick}/>
</div>
<div class="settings-row">
<button id="set-mask" class="corner-btn" onClick={this.set}>Set</button>
</div>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
label {
display: inline-block;
width: 135px;
}
.settings-row {
width: 100%;
height: 30px;
font-size: 13px;
}
.settings-text {
display: inline-block;
width: 100px;
}
.settings-btn {
display: inline-block;
width: 100px;
height: 30px;
margin-left: 20px;
}
#validation {
font-size: 10px;
color: red;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);